diff -Nru cryptsetup-1.4.3/debian/initramfs/cryptroot-hook cryptsetup-1.4.3/debian/initramfs/cryptroot-hook
--- cryptsetup-1.4.3/debian/initramfs/cryptroot-hook	2012-04-11 22:34:23.000000000 +0100
+++ cryptsetup-1.4.3/debian/initramfs/cryptroot-hook	2013-06-10 17:04:25.000000000 +0100
@@ -503,6 +503,12 @@
 rootdev=""
 resumedevs=""
 
+# Include cryptsetup modules, regardless of _this_ machine
+# configuration
+if [ -n "$CRYPTSETUP" ] && [ "$CRYPTSETUP" != "n" ]; then
+    setup="yes"
+fi
+
 # Find the root and resume device(s)
 if [ -r /etc/crypttab ]; then
 	rootdev=$(get_root_device)
@@ -534,14 +547,14 @@
 done
 
 # With large initramfs, we always add a basic subset of modules
-if [ "$MODULES" != "dep" ]; then
+if [ "$MODULES" != "dep" ] && [ "$setup" = "yes" ]; then
 	for mod in aes cbc chainiv cryptomgr krng sha256 xts; do
 		add_crypto_modules $mod
 	done
 fi
 
 # See if we need to add the basic components
-if [ "$MODULES" != "dep" ] || [ "$setup" = "yes" ]; then
+if [ "$setup" = "yes" ]; then
 	for mod in dm_mod dm_crypt; do
 		manual_add_modules $mod
 	done
